/* FSPoint.h Copyright (c) 1998-2004 Philippe Mougin.  */
/*   This software is open source. See the license.  */  

#import <Foundation/Foundation.h>

@class Rectangle; 

@interface FSPoint : NSObject <NSCopying , NSCoding>
{
  NSPoint rep;
}

// METHODS

+ (FSPoint *)pointWithNSPoint:(NSPoint)p;

- (id)copyWithZone:(NSZone *)zone;
- (NSString *)description;
- (void)encodeWithCoder:(NSCoder *)coder;
- (unsigned int)hash;
- (id)initWithCoder:(NSCoder *)coder;
- (FSPoint *)initWithNSPoint:(NSPoint)p;
- (BOOL)isEqual:(id)anObject;
- (NSPoint)NSPointValue;


///////////////////////////////// USER METHODS /////////////////////////

- (id)clone;
- (Rectangle *)extent:(FSPoint *)extent;
- (void)setValue:(id)operand;
- (NSNumber *)x;
- (NSNumber *)y;
- (void)x:(float)x;
- (void)y:(float)y;

@end
