/* FSSize.h Copyright (c) 1998-2004 Philippe Mougin.  */
/*   This software is open source. See the license.  */  

#import <Foundation/Foundation.h>

@interface FSSize : NSObject <NSCopying , NSCoding>
{
  NSSize rep;
}

// METHODS

+ (FSSize *)sizeWithNSSize:(NSSize)p;

- (id)copyWithZone:(NSZone *)zone;
- (NSString *)description;
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
- (FSSize *)initWithNSSize:(NSSize)p;
- (BOOL)isEqual:(id)anObject;
- (NSSize)NSSizeValue;


///////////////////////////////// USER METHODS /////////////////////////

+ (FSSize *)width:(float)w height:(float)h;

- (id)clone;
- (void)setValue:(id)operand;
- (NSNumber *)width;
- (NSNumber *)height;
- (void)width: (float)w;
- (void)height:(float)h;

@end
