/*   Range.h Copyright (c)  2001-2004 Philippe Mougin.   */
/*   This software is open source. See the license. */ 

#import <Foundation/Foundation.h>

@interface Range : NSObject <NSCopying , NSCoding>
{
  NSRange rep;
}

// METHODS

+ (Range *)rangeWithNSRange:(NSRange)r;

- (id)copyWithZone:(NSZone *)zone;
- (NSString *)description;
- (void)encodeWithCoder:(NSCoder *)coder;
- (id)initWithCoder:(NSCoder *)coder;
- (Range *)initWithNSRange:(NSRange)r;
- (BOOL)isEqual:(id)anObject;
- (NSRange)NSRangeValue;


///////////////////////////////// USER METHODS /////////////////////////

+ (Range *)location:(unsigned int)location length:(unsigned int)length;

- (id)clone;
- (void)setValue:(id)operand;
- (NSNumber *)length;
- (void)length:(unsigned int)l;
- (NSNumber *)location;
- (void)location: (unsigned int)l;

@end
