/* Rectangle.h Copyright (c) 1998-2004 Philippe Mougin.  */
/*   This software is open source. See the license.  */  

#import <Foundation/Foundation.h>

@class FSPoint, FSSize;

@interface Rectangle : NSObject <NSCopying , NSCoding>
{
  NSRect rep;
}

// METHODS

+ (Rectangle *)rectangleWithNSRect:(NSRect)p;

- (id)copyWithZone:(NSZone *)zone;
- (NSString *)description;
- (void)encodeWithCoder:(NSCoder *)coder;
- (unsigned int)hash;
- (id)initWithCoder:(NSCoder *)coder;
- (Rectangle *)initWithNSRect:(NSRect)p;
- (BOOL)isEqual:(id)anObject;
- (NSRect)NSRectValue;


///////////////////////////////// USER METHODS /////////////////////////

- (id)clone;
- (FSPoint *)corner;
- (void)corner:(FSPoint *)corner;
- (FSPoint *)extent;
- (void)extent:(FSPoint *)extent;
- (void)setValue:(id)operand;
- (FSSize *)size;
- (FSPoint *)origin;

@end
